(function (_, Kotlin, $module$mpe_js, $module$kotlin_test) {
  'use strict';
  var appendSeven = $module$mpe_js.com.dupont.util.appendSeven_dqglrj$;
  var message = $module$mpe_js.com.dupont.midi.message;
  var ControlChangeMessage$RpnMessage = $module$mpe_js.com.dupont.midi.message.ControlChangeMessage.RpnMessage;
  var Exception_init = Kotlin.kotlin.Exception_init_pdl1vj$;
  var assertFalse = $module$kotlin_test.kotlin.test.assertFalse_i7pyzi$;
  var assertTrue = $module$kotlin_test.kotlin.test.assertTrue_i7pyzi$;
  var Kind_CLASS = Kotlin.Kind.CLASS;
  var assertEquals = $module$kotlin_test.kotlin.test.assertEquals_3m0tl5$;
  var splitSeven = $module$mpe_js.com.dupont.util.splitSeven_s8ev3n$;
  var fitToRange = $module$mpe_js.com.dupont.util.fitToRange_2jm0ic$;
  var test = $module$kotlin_test.kotlin.test.test;
  var suite = $module$kotlin_test.kotlin.test.suite;
  function SimpleTest() {
  }
  function SimpleTest$testRpn_noTrailingNulls$lambda(closure$message) {
    return function () {
      return closure$message.isComplete;
    };
  }
  function SimpleTest$testRpn_noTrailingNulls$lambda_0(closure$message) {
    return function () {
      return closure$message.isComplete;
    };
  }
  function SimpleTest$testRpn_noTrailingNulls$lambda_1(closure$message, closure$expectedValue) {
    return function () {
      return closure$message.rpn === closure$expectedValue;
    };
  }
  function SimpleTest$testRpn_noTrailingNulls$lambda_2(closure$message, closure$expectedValue) {
    return function () {
      return closure$message.value === closure$expectedValue;
    };
  }
  SimpleTest.prototype.testRpn_noTrailingNulls = function () {
    var tmp$, tmp$_0, tmp$_1, tmp$_2;
    var statusByte = 177;
    var msb = 2;
    var lsb = 2;
    var expectedValue = appendSeven(msb, lsb);
    var rpnBytes = [new Int32Array([statusByte, message.RPN_MSB_CODE, msb]), new Int32Array([statusByte, message.RPN_LSB_CODE, lsb]), new Int32Array([statusByte, message.RPN_VALUE_MSB_CODE, msb]), new Int32Array([statusByte, message.RPN_VALUE_LSB_CODE, lsb])];
    for (var x = 0; x <= 2; x++) {
      tmp$_0 = Kotlin.isType(tmp$ = message.GlobalParser.parseAsMidiMessage_q5rwfd$(rpnBytes[x]), ControlChangeMessage$RpnMessage) ? tmp$ : null;
      if (tmp$_0 == null) {
        throw Exception_init('Not a RPN message');
      }
      var message_0 = tmp$_0;
      assertFalse(void 0, SimpleTest$testRpn_noTrailingNulls$lambda(message_0));
    }
    tmp$_2 = Kotlin.isType(tmp$_1 = message.GlobalParser.parseAsMidiMessage_q5rwfd$(rpnBytes[3]), ControlChangeMessage$RpnMessage) ? tmp$_1 : null;
    if (tmp$_2 == null) {
      throw Exception_init('Not a RPN message');
    }
    var message_1 = tmp$_2;
    assertTrue(void 0, SimpleTest$testRpn_noTrailingNulls$lambda_0(message_1));
    assertTrue(void 0, SimpleTest$testRpn_noTrailingNulls$lambda_1(message_1, expectedValue));
    assertTrue(void 0, SimpleTest$testRpn_noTrailingNulls$lambda_2(message_1, expectedValue));
  };
  function SimpleTest$testRpn_trailingNulls$lambda(closure$message) {
    return function () {
      return closure$message.isComplete;
    };
  }
  function SimpleTest$testRpn_trailingNulls$lambda_0(closure$message) {
    return function () {
      return closure$message.isComplete;
    };
  }
  function SimpleTest$testRpn_trailingNulls$lambda_1(closure$message) {
    return function () {
      return closure$message.isComplete;
    };
  }
  function SimpleTest$testRpn_trailingNulls$lambda_2(closure$message) {
    return function () {
      return closure$message.readyToDispose;
    };
  }
  function SimpleTest$testRpn_trailingNulls$lambda_3(closure$message, closure$expectedValue) {
    return function () {
      return closure$message.rpn === closure$expectedValue;
    };
  }
  function SimpleTest$testRpn_trailingNulls$lambda_4(closure$message, closure$expectedValue) {
    return function () {
      return closure$message.value === closure$expectedValue;
    };
  }
  SimpleTest.prototype.testRpn_trailingNulls = function () {
    var tmp$, tmp$_0, tmp$_1, tmp$_2, tmp$_3, tmp$_4;
    var statusByte = 177;
    var msb = 2;
    var lsb = 2;
    var expectedValue = appendSeven(msb, lsb);
    var rpnBytes = [new Int32Array([statusByte, message.RPN_MSB_CODE, msb]), new Int32Array([statusByte, message.RPN_LSB_CODE, lsb]), new Int32Array([statusByte, message.RPN_VALUE_MSB_CODE, msb]), new Int32Array([statusByte, message.RPN_VALUE_LSB_CODE, lsb]), new Int32Array([statusByte, message.RPN_MSB_CODE, message.RPN_VALUE_NULL]), new Int32Array([statusByte, message.RPN_LSB_CODE, message.RPN_VALUE_NULL])];
    for (var x = 0; x <= 2; x++) {
      tmp$_0 = Kotlin.isType(tmp$ = message.GlobalParser.parseAsMidiMessage_q5rwfd$(rpnBytes[x]), ControlChangeMessage$RpnMessage) ? tmp$ : null;
      if (tmp$_0 == null) {
        throw Exception_init('Not a RPN message');
      }
      var message_0 = tmp$_0;
      assertFalse(void 0, SimpleTest$testRpn_trailingNulls$lambda(message_0));
    }
    for (var x_0 = 3; x_0 <= 4; x_0++) {
      tmp$_2 = Kotlin.isType(tmp$_1 = message.GlobalParser.parseAsMidiMessage_q5rwfd$(rpnBytes[x_0]), ControlChangeMessage$RpnMessage) ? tmp$_1 : null;
      if (tmp$_2 == null) {
        throw Exception_init('Not a RPN message');
      }
      var message_1 = tmp$_2;
      assertTrue(void 0, SimpleTest$testRpn_trailingNulls$lambda_0(message_1));
    }
    tmp$_4 = Kotlin.isType(tmp$_3 = message.GlobalParser.parseAsMidiMessage_q5rwfd$(rpnBytes[5]), ControlChangeMessage$RpnMessage) ? tmp$_3 : null;
    if (tmp$_4 == null) {
      throw Exception_init('Not a RPN message');
    }
    var message_2 = tmp$_4;
    assertTrue(void 0, SimpleTest$testRpn_trailingNulls$lambda_1(message_2));
    assertTrue(void 0, SimpleTest$testRpn_trailingNulls$lambda_2(message_2));
    assertTrue(void 0, SimpleTest$testRpn_trailingNulls$lambda_3(message_2, expectedValue));
    assertTrue(void 0, SimpleTest$testRpn_trailingNulls$lambda_4(message_2, expectedValue));
  };
  function SimpleTest$testRpn_trailingNulls_noLsb$lambda(closure$message) {
    return function () {
      return closure$message.isComplete;
    };
  }
  function SimpleTest$testRpn_trailingNulls_noLsb$lambda_0(closure$message) {
    return function () {
      return closure$message.v.isComplete;
    };
  }
  function SimpleTest$testRpn_trailingNulls_noLsb$lambda_1(closure$message) {
    return function () {
      return closure$message.v.isComplete;
    };
  }
  function SimpleTest$testRpn_trailingNulls_noLsb$lambda_2(closure$message) {
    return function () {
      return closure$message.v.readyToDispose;
    };
  }
  function SimpleTest$testRpn_trailingNulls_noLsb$lambda_3(closure$message, closure$expectedValue) {
    return function () {
      return closure$message.v.rpn === closure$expectedValue;
    };
  }
  function SimpleTest$testRpn_trailingNulls_noLsb$lambda_4(closure$message, closure$msb) {
    return function () {
      return closure$message.v.value === closure$msb;
    };
  }
  SimpleTest.prototype.testRpn_trailingNulls_noLsb = function () {
    var tmp$, tmp$_0, tmp$_1, tmp$_2, tmp$_3, tmp$_4;
    var statusByte = 177;
    var msb = 2;
    var lsb = 2;
    var expectedValue = appendSeven(msb, lsb);
    var rpnBytes = [new Int32Array([statusByte, message.RPN_MSB_CODE, msb]), new Int32Array([statusByte, message.RPN_LSB_CODE, lsb]), new Int32Array([statusByte, message.RPN_VALUE_MSB_CODE, msb]), new Int32Array([statusByte, message.RPN_MSB_CODE, message.RPN_VALUE_NULL]), new Int32Array([statusByte, message.RPN_LSB_CODE, message.RPN_VALUE_NULL])];
    for (var x = 0; x <= 2; x++) {
      tmp$_0 = Kotlin.isType(tmp$ = message.GlobalParser.parseAsMidiMessage_q5rwfd$(rpnBytes[x]), ControlChangeMessage$RpnMessage) ? tmp$ : null;
      if (tmp$_0 == null) {
        throw Exception_init('Not a RPN message');
      }
      var message_0 = tmp$_0;
      assertFalse(void 0, SimpleTest$testRpn_trailingNulls_noLsb$lambda(message_0));
    }
    tmp$_2 = Kotlin.isType(tmp$_1 = message.GlobalParser.parseAsMidiMessage_q5rwfd$(rpnBytes[3]), ControlChangeMessage$RpnMessage) ? tmp$_1 : null;
    if (tmp$_2 == null) {
      throw Exception_init('Not a RPN message');
    }
    var message_1 = {v: tmp$_2};
    assertTrue(void 0, SimpleTest$testRpn_trailingNulls_noLsb$lambda_0(message_1));
    tmp$_4 = Kotlin.isType(tmp$_3 = message.GlobalParser.parseAsMidiMessage_q5rwfd$(rpnBytes[4]), ControlChangeMessage$RpnMessage) ? tmp$_3 : null;
    if (tmp$_4 == null) {
      throw Exception_init('Not a RPN message');
    }
    message_1.v = tmp$_4;
    assertTrue(void 0, SimpleTest$testRpn_trailingNulls_noLsb$lambda_1(message_1));
    assertTrue(void 0, SimpleTest$testRpn_trailingNulls_noLsb$lambda_2(message_1));
    assertTrue(void 0, SimpleTest$testRpn_trailingNulls_noLsb$lambda_3(message_1, expectedValue));
    assertTrue(void 0, SimpleTest$testRpn_trailingNulls_noLsb$lambda_4(message_1, msb));
  };
  SimpleTest.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'SimpleTest',
    interfaces: []
  };
  function UtilTests() {
  }
  UtilTests.prototype.testAppendSeven = function () {
    var x = 1;
    var expected = 129;
    var result = appendSeven(x, x);
    assertEquals(expected, result);
  };
  UtilTests.prototype.testSplitSeven = function () {
    var x = 129;
    var expected = 1;
    var tmp$ = splitSeven(x);
    var msb = tmp$.component1()
    , lsb = tmp$.component2();
    assertEquals(expected, msb);
    assertEquals(expected, lsb);
  };
  UtilTests.prototype.testFitToRange_middle = function () {
    var expected = 0.0;
    var result = fitToRange(0.0, -2, 2);
    assertEquals(expected, result);
  };
  UtilTests.prototype.testFitToRange_middleOffSetRange = function () {
    var expected = 1.0;
    var result = fitToRange(0.0, -1, 3);
    assertEquals(expected, result);
  };
  UtilTests.prototype.testFitToRange_middleOffSetRangeDown = function () {
    var expected = -1.0;
    var result = fitToRange(0.0, -3, 1);
    assertEquals(expected, result);
  };
  UtilTests.prototype.testFitToRange_upper = function () {
    var expected = 1.0;
    var result = fitToRange(0.5, -2, 2);
    assertEquals(expected, result);
  };
  UtilTests.prototype.testFitToRange_top = function () {
    var expected = 2.0;
    var result = fitToRange(1.0, -2, 2);
    assertEquals(expected, result);
  };
  UtilTests.prototype.testFitToRange_bottom = function () {
    var expected = -2.0;
    var result = fitToRange(-1.0, -2, 2);
    assertEquals(expected, result);
  };
  UtilTests.prototype.testFitToRange_outOfRange = function () {
    var expected = 2.0;
    var result = fitToRange(3.0, -2, 2);
    assertEquals(expected, result);
  };
  UtilTests.$metadata$ = {
    kind: Kind_CLASS,
    simpleName: 'UtilTests',
    interfaces: []
  };
  var package$com = _.com || (_.com = {});
  var package$dupont = package$com.dupont || (package$com.dupont = {});
  var package$midi = package$dupont.midi || (package$dupont.midi = {});
  package$midi.SimpleTest = SimpleTest;
  var package$util = package$dupont.util || (package$dupont.util = {});
  package$util.UtilTests = UtilTests;
  suite('com.dupont.midi', false, function () {
    suite('SimpleTest', false, function () {
      test('testRpn_noTrailingNulls', false, function () {
        return (new SimpleTest()).testRpn_noTrailingNulls();
      });
      test('testRpn_trailingNulls', false, function () {
        return (new SimpleTest()).testRpn_trailingNulls();
      });
      test('testRpn_trailingNulls_noLsb', false, function () {
        return (new SimpleTest()).testRpn_trailingNulls_noLsb();
      });
    });
  });
  suite('com.dupont.util', false, function () {
    suite('UtilTests', false, function () {
      test('testAppendSeven', false, function () {
        return (new UtilTests()).testAppendSeven();
      });
      test('testSplitSeven', false, function () {
        return (new UtilTests()).testSplitSeven();
      });
      test('testFitToRange_middle', false, function () {
        return (new UtilTests()).testFitToRange_middle();
      });
      test('testFitToRange_middleOffSetRange', false, function () {
        return (new UtilTests()).testFitToRange_middleOffSetRange();
      });
      test('testFitToRange_middleOffSetRangeDown', false, function () {
        return (new UtilTests()).testFitToRange_middleOffSetRangeDown();
      });
      test('testFitToRange_upper', false, function () {
        return (new UtilTests()).testFitToRange_upper();
      });
      test('testFitToRange_top', false, function () {
        return (new UtilTests()).testFitToRange_top();
      });
      test('testFitToRange_bottom', false, function () {
        return (new UtilTests()).testFitToRange_bottom();
      });
      test('testFitToRange_outOfRange', false, function () {
        return (new UtilTests()).testFitToRange_outOfRange();
      });
    });
  });
  Kotlin.defineModule('mpe-js_test', _);
  return _;
}(module.exports, require('kotlin'), require('mpe-js'), require('kotlin-test')));
